unit TEMainFrm;

{------------------------------------------------------------------------------}
{
  Very simple template editor for "mail merging"
  It loads and saves a template in TEMPLATE.RVF.
  This demo is a modified version of the demo in
  Demos\Delphi\Assorted\Fields\MailMerge\

  The main difference - it does not use a predefined set of styles.
  It does not use a fixed text style index for fields - it creates styles for
  them on the fly.

  See mail merging application in the same directory - MAILMERGE.

}
{------------------------------------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, RVStyle, RVScroll, RichView, RVEdit, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    rve: TRichViewEdit;
    RVStyle1: TRVStyle;
    Button4: TButton;
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    function GetFieldStyleNo: Integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  rve.LoadRVF(ExtractFilePath(Application.ExeName)+'template.rvf');
  rve.Format;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  rve.SaveRVF(ExtractFilePath(Application.ExeName)+'template.rvf', False);
end;
{------------------------------------------------------------------------------}
{
  Returns the index of text style for new field.
  This style has the same properties as the current style, but some
  Protection options.
  If this style already exists, this procedure returns its index.
  Otherwise, it create a new style and returns its index.
}
function TForm1.GetFieldStyleNo: Integer;
var fi: TFontInfo;
begin
  fi := TFontInfo.Create(nil);
  fi.Assign(RVStyle1.TextStyles[rve.CurTextStyleNo]);
  fi.Protection := [rvprStyleProtect, rvprModifyProtect, rvprConcateProtect,
    rvprDoNotAutoSwitch];
  Result := RVStyle1.FindTextStyle(fi);
  fi.Free;
end;
{------------------------------------------------------------------------------}
{
  Inserting a field "code". Text of this item does not matter, but tag
  is important and equal to "code".
  Since rvprDoNotAutoSwitch is in Protection of the field text style,
  a current style will be switched back to previous value after insertion.
}
procedure TForm1.Button1Click(Sender: TObject);
begin
  rve.CurTextStyleNo := GetFieldStyleNo;
  rve.InsertStringWTag('{code}', 'code');
  rve.SetFocus;
end;
{------------------------------------------------------------------------------}
{
  Inserting a field "name".
}
procedure TForm1.Button2Click(Sender: TObject);
begin
  rve.CurTextStyleNo := GetFieldStyleNo;
  rve.InsertStringWTag('{name}', 'name');
  rve.SetFocus;
end;



end.
